-- Ranch
-- Author: Blue Ghost, adan_eslavo
-- DateCreated:
--------------------------------------------------------------
include("FLuaVector.lua")

local eCivilizationInuit = GameInfoTypes.CIVILIZATION_CLINUIT

-- aquires new tiles on construction of Ranch (Cattle, Horse, Sheep and Bison), 3 range of city
function OnConstructionBuildIgluviak(iPlayer, iCity, iBuilding)
	local pPlayer = Players[iPlayer]

	if not (pPlayer and pPlayer:GetCivilizationType() == eCivilizationInuit) then return end
	if iBuilding ~= GameInfoTypes.BUILDING_CLINUIT_IGLOO then return end

	local pCity = pPlayer:GetCityByID(iCity)
	local tPossibleSpots = {}
	local iCityX, iCityY = pCity:GetX(), pCity:GetY()
	local sCityName = pCity:GetName()
	
	for iCityPlot = 1, pCity:GetNumCityPlots() - 1, 1 do
		local pSpecificPlot = pCity:GetCityIndexPlot(iCityPlot)
		
		if (pSpecificPlot:GetTerrainType() == TerrainTypes.TERRAIN_SNOW) then 
			if (pSpecificPlot:GetResourceType(-1) == (-1) and pSpecificPlot:GetImprovementType() == (-1) and not pSpecificPlot:IsCity() and not pSpecificPlot:IsMountain()) then

				local iPlotOwner = pSpecificPlot:GetOwner()
				if iPlotOwner == iPlayer or iPlotOwner == -1 then
					tPossibleSpots[#tPossibleSpots + 1] = pSpecificPlot
				end
			end
		end
	end

	if #tPossibleSpots <= 0 then
		pNearestCity = GetNearestCity(pPlayer, pMainPlot)

		if pPlayer:IsHuman() and pPlayer:IsTurnActive() then
			pPlayer:AddNotification(0, 
			'There was no suitable place near [COLOR_CYAN]'..sCityName..'[ENDCOLOR] to build an Igluviak.', 
			'Cannot build Igvluviak near '..sCityName, 
			iCityX, iCityY)
		end	
		return 
	end

	local iChosenPlot = Game.Rand(#tPossibleSpots - 1, "") + 1
	local pChosenPlot = tPossibleSpots[iChosenPlot]
	pChosenPlot:SetOwner(iPlayer, iCity, 1, 1)
	pChosenPlot:SetImprovementType(GameInfoTypes.IMPROVEMENT_INUIT_IGLOO)	
	
	if pPlayer:IsHuman() and pPlayer:IsTurnActive() then
		pPlayer:AddNotification(0, 
		'An Igluviak has been built near [COLOR_CYAN]'..sCityName..'[ENDCOLOR]!', 
		'Igvluviak built near '..sCityName, 
		iCityX, iCityY)
	end	
	return 
end
	
if Game.IsCivEverActive(eCivilizationInuit) then
	GameEvents.CityConstructed.Add(OnConstructionBuildIgluviak)
end


